<template>
  <v-col id="app-menu">
    <v-row align="center" justify="center" class="ma-2">
      <v-avatar
        color="primary"
        size="128"
      >
        <v-img
          src="/img/logo.jpg"
          alt=""
        />
      </v-avatar>
    </v-row>
    <v-row justify="center" class="ma-2">
      <span class="font-weight-bold">sysVet</span>
    </v-row>
    <v-row justify="end" class="mx-2">
      <!--<v-switch
        @change="toggleTheme()"
      />-->
      <label id="switch" class="switch">
        <input id="slider" type="checkbox" @change="toggleTheme()">
        <span class="slider round" />
      </label>
    </v-row>
    <v-divider />
    <v-list id="lista-menu-principal" height="60vh" dense shaped>
      <v-list-item-group color="accent2">
        <template v-for="(item,index) in items">
          <!--Border Top-->
          <v-divider v-if="item.borderTop" :key="item" class="my-1" />
          <!--Type Linea-->
          <v-divider v-if="item.type==='line'" :key="item" />
          <!-- Type group -->
          <v-list-group
            v-else-if="item.type === 'group'"
            :key="index"
            v-model="item.model"
            class="lista iconolista"
            :prepend-icon="item.icon"
            :append-icon="item.model ? item.flecha : item['flecha-alt']"
          >
            <template #activator>
              <v-list-item>
                <v-list-item-content>
                  <v-list-item-title>
                    {{ item.text }}
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </template>
            <v-list-item
              v-for="(child, i) in item.children"
              :key="i"
              :class="{'menu-item menu-sub-item':true, active: urlactiva===child.url}"
              @click="redireccionar(child.url)"
            >
              <v-list-item-action v-if="child.icon">
                <v-icon>{{ child.icon }}</v-icon>
              </v-list-item-action>
              <v-list-item-content>
                <v-list-item-title>
                  {{ child.text }}
                </v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list-group>
          <!--Type simple|defualt-->
          <v-list-item
            v-else
            :key="index"
            :class="{
              'menu-item':true,
              'v-item--active v-list-item--active active': urlactiva===item.url
            }"
            @click="redireccionar(item.url)"
          >
            <v-list-item-icon>
              <v-icon>{{ item.icon }}</v-icon>
            </v-list-item-icon>
            <v-list-item-content>
              <v-list-item-title v-text="item.text" />
            </v-list-item-content>
          </v-list-item>
          <!--Border Bottom-->
          <v-divider v-if="item.borderBottom" :key="item" class="my-1" />
        </template>
      </v-list-item-group>
    </v-list>
    <v-list>
      <v-list-item color="accent2" @click="cerrarSesion()">
        <v-list-item-icon>
          <v-icon>fal fa-sign-out-alt</v-icon>
        </v-list-item-icon>
        <v-list-item-content>
          <v-list-item-title>
            Cerrar sesión
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item color="accent2" @click="abrirFAQ()">
        <v-list-item-icon>
          <v-icon>fal fa-question</v-icon>
        </v-list-item-icon>
        <v-list-item-content>
          <v-list-item-title>
            FAQ
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </v-list>
    <v-row class="mt-3" justify="center">
      <span class="caption">© Copyright sysVet</span>
    </v-row>
  </v-col>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import { UserType } from '~/core/enums/userType'
import { AuthStore } from '~/store/AuthStore'
import { User } from '~/core/models/user'
import AppUserMenu from '~/components/layouts/AppUserMenu.vue'

  interface menuItem {
    type?: 'simple'|'line'|'headers'|'group',

    icon?:string,
    text: string,
    model?:boolean,
    children?:menuItem[],
    'icon-alt'?:string,
    url?:string,

    borderTop?:boolean,
    borderBottom?:boolean,
    flecha?:string,
    'flecha-alt'?:string,

    minUser?:UserType,
    onlyUsers?:UserType[],
    onlyXs?:boolean

  }

  @Component({
    components: { AppUserMenu }
  })
export default class AppMenu extends Vue {
    menuModel = 0;

    private menu:menuItem[] = [
      {
        icon: 'fal fa-home',
        text: 'Inicio',
        url: '/'
      },
      {
        icon: 'fal fa-badge-dollar',
        text: 'Ventas',
        url: '/ventas',
        onlyUsers: [UserType.RECEPCIONISTA, UserType.ADMIN]
      },
      {
        icon: 'fas fa-barcode',
        text: 'Productos y Servicios',
        url: '/productos',
        onlyUsers: [UserType.RECEPCIONISTA, UserType.ADMIN]
      },
      {
        icon: 'fal fa-parachute-box',
        text: 'Proveedores',
        url: '/proveedores',
        onlyUsers: [UserType.RECEPCIONISTA, UserType.ADMIN]
      },
      {
        icon: 'fal fa-user-friends',
        text: 'Clientes',
        url: '/clientes',
        onlyUsers: [UserType.RECEPCIONISTA, UserType.ADMIN]
      },
      {
        icon: 'fal fa-calendar-day',
        text: 'Turnos',
        url: '/turnos'
      },
      {
        icon: 'fal fa-user-md',
        text: 'Veterinarios',
        url: '/veterinarios',
        onlyUsers: [UserType.VETERINARIO, UserType.ADMIN]
      },
      {
        icon: 'fal fa-notes-medical',
        text: 'Historias Clínicas',
        url: '/historiasClinicas',
        onlyUsers: [UserType.VETERINARIO, UserType.ADMIN]
      }
    ];

    get user ():User {
      return AuthStore.user
    }

    toggleTheme () {
      this.$vuetify.theme.dark = !this.$vuetify.theme.dark
    };

    get urlactiva () {
      return this.$route.path
    }

    get items ():menuItem[] {
      return this.user
        ? this.menu.filter((item) => {
          if (item.minUser !== undefined) {
          // filtrar por min user
            if (this.user.tipo < item.minUser) {
              return false
            }
          }

          if (item.onlyUsers !== undefined) {
            if (!item.onlyUsers.includes(this.user.tipo)) {
            // el tipo de usuario no esta en la lista del menu
              return false
            }
          }

          return true
        })
        : []
    }

    redireccionar (url) {
      const { urlactiva } = this
      if (url !== urlactiva) {
        this.$router.push(url)
      }
      // https://router.vuejs.org/guide/essentials/navigation.html
    }

    cerrarSesion () {
      AuthStore.logout()
      this.$router.push('/login')
      // redireccionamos a la pagina login
    }

    abrirFAQ () {
      window.open('https://drive.google.com/file/d/1RuSZpTVT32gNKT6dPdSf7qNaOeI6nDkL/view?usp=sharing', '_blank')
    }
}
</script>

<style lang="scss">
  #app-menu{

    padding: 0 !important;
    $color1: $primary-color;
    $color2: $accent-color;

    #lista-menu-principal{
      .menu-item.active{
        background: rgba(34,40,49,0.1);
        .v-list-item__action i, .v-list-item__title, .v-list-item__icon{
          color: $color2;
        }
      }
    }

  }

  .switch {
    position: relative;
    display: inline-block;
    width: 50px;
    height: 24px;
    margin-bottom: 20px;
  }

  /* Hide default HTML checkbox */
  .switch input {
    opacity: 0;
    width: 0;
    height: 0;
  }

  /* The slider */
  .slider {
    position: absolute;
    cursor: pointer;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background-color: #ccc;
    -webkit-transition: 0.4s;
    transition: 0.4s;
  }

  .slider:before {
    position: absolute;
    content: "";
    height: 30px;
    width: 30px;
    left: 0;
    bottom: 4px;
    top: 0;
    margin: -4px 0 0 0;
    -webkit-transition: 0.4s;
    transition: 0.4s;
    box-shadow: 0 0 15px #2020203d;
    background: white url('static/img/sun-solid.svg') no-repeat center;
    background-size: 75%;
  }

  input:checked + .slider {
    background-color: $accent-color;
  }

  input:focus + .slider {
    box-shadow: 0 0 1px $accent-color;
  }

  input:checked + .slider:before {
    -webkit-transform: translateX(24px);
    -ms-transform: translateX(24px);
    transform: translateX(24px);
    background: white url('static/img/moon-solid.svg') no-repeat center;
    background-size: 75%;
  }

  /* Rounded sliders */
  .slider.round {
    border-radius: 34px;
  }

  .slider.round:before {
    border-radius: 50%;
  }
</style>
